# -*- coding: utf-8 -*-
"""Copy of Text_emotion_predictor.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1eI9V1AkiReSDcB6wk_6XjbT5wfETw1Un
"""

# Imports and settings.
import torch
import torch.nn as nn
import numpy as np
from keras.preprocessing.text import Tokenizer
from keras.preprocessing.sequence import pad_sequences
from transformers import BertTokenizer
from transformers import BertForSequenceClassification, AdamW, BertConfig,BertModel


#This class is the implementation of Bert classifier i.e simple Bert with an extra classification layer on top.
#We use the Bert model implementation as provided by the huggingface library
#Link can be fount at https://huggingface.co/transformers/_modules/transformers/modeling_bert.html

class BertClassifier(nn.Module):
    def __init__(self, model_name, num_labels, dropout_prob=0.5, bert_hidden_size=768):


        # Initializes the BertClassifier model object.

        # Parameters:
        #     model_name: {String} exact name of the Bert model to be used during training. (Usually "bert-base-uncased")
        #     num_labels: {int} Number of labels.
        #     dropout_prob : {float} The dropout probability for the classification layer.
        #     bert_hidden_size: {int} Bert hidden dimension for its last-output layer. (Usually for "bert-base-uncased" is 768)

        super().__init__()
        self.num_labels = num_labels
        self.bert = BertModel.from_pretrained(model_name)
        self.dropout = nn.Dropout(dropout_prob)
        self.l1 = nn.Linear(bert_hidden_size,num_labels)


    def forward(self, input_ids = None, attention_mask = None):
        # Processes the input data to produce the classification output and the attention weight tensor.

        # Parameters:
        #     input_data: {torch.Tensor} Input data.
        #     attention_mask: {torch.Tensor} Indices to avoid performing attention to due to padded tokens

        outputs = self.bert(input_ids, attention_mask = attention_mask)
        pooled_output = outputs[1]
        pooled_output = self.dropout(pooled_output)
        outputs = self.l1(pooled_output)
        outputs = torch.log_softmax(outputs,1)
        return outputs

def tokenize_map_pad_mask(sentences,MAX_LEN = 35):
  tokenizer = BertTokenizer.from_pretrained('bert-base-uncased', do_lower_case=True)
  # Tokenize all of the sentences and map the tokens to thier word IDs.
  input_ids = []
  for sent in sentences:
    # `encode` will:
    #   (1) Tokenize the sentence.
    #   (2) Prepend the `[CLS]` token to the start.
    #   (3) Append the `[SEP]` token to the end.
    #   (4) Map tokens to their IDs.
    encoded_sent = tokenizer.encode(
                        sent,
                        add_special_tokens = True, # Add '[CLS]' and '[SEP]'
                  )

    # Add the encoded sentence to the list.
    input_ids.append(encoded_sent)
    #pad the sentences
  input_ids = pad_sequences(input_ids, maxlen=MAX_LEN, dtype="long",
                        value=0, truncating="post", padding="post")


  # Create attention masks which provide the indices to avoid performing attention to due to padded tokens
  attention_masks = []
  for sent in input_ids:
      # Create the attention mask.
      #   - If a token ID is 0, then it's padding, set the mask to 0.
      #   - If a token ID is > 0, then it's a real token, set the mask to 1.
      att_mask = [int(token_id > 0) for token_id in sent]
      attention_masks.append(att_mask)
  return input_ids,attention_masks

def predict(model,array_of_sentences):
  test_input, test_masks = tokenize_map_pad_mask(array_of_sentences,35)
  # Convert to tensors.
  test_input = torch.tensor(test_input)
  test_masks = torch.tensor(test_masks)
  model.eval()

  if torch.cuda.is_available():
    device = torch.device("cuda")
  else:
    device = torch.device("cpu")

  with torch.no_grad():
      outputs = model(test_input.to(device), attention_mask = test_masks.to(device))

  labels_dict = {0: "Anger", 1: "Fear", 2: "Sadness", 3: "Happiness"}
  for i in range(0,len(outputs)):
    print(labels_dict[np.argmax(outputs[i].cpu()).item()])
    print(outputs[i])

sentence1 = 'I hate the fact that all nice foods are fattening'
sentence2 = 'Today my emotions were up and down all the time. I ended up crying in the room '
sentence3 = ' my husband propose it was beautiful'
sentences = [sentence1,sentence2,sentence3]
#path to model's weights
path = "bert_classifier.pth"

device = torch.device("cpu")
#if torch.cuda.is_available():
new_model = torch.load(path,map_location=device)
predict(new_model,sentences)
#else:
#  print('Make sure you enabled GPU usage')
